/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//                                  //
//                             . ..                        //
//                                                                         //
//         : TArmoringTicket.cpp                                       //
//                                                                         //
//   :               //
//                                                      //
//                                                                         //
//  ()   :  ..,  ..,  ..                    //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

#include "TArmoringTicket.h"

namespace NS_ARMORING_TICKET {
	TArmoringTicket::TArmoringTicket(IDataAccess * pIDataAccess)
	{
		this->pIDataAccess = pIDataAccess;
		this->pIFitingFlight = new NS_FITING_FLIGHT ::TFitingFlight(this->pIDataAccess);
		this->pTRouteFlight = new TRouteFlight();
	}

	TArmoringTicket::~TArmoringTicket(void)
	{
		this->pIDataAccess = NULL;
		delete this->pIFitingFlight;
		delete this->pTRouteFlight;
	}
/**
* : 
*        (  , 
*      getRouteFlight  )
* :
*   
*  :
*    
*    0 -   
*   -1 - pIDataAccess == NULL
*   -2 - pIFitingFlight == NULL
*   -3 - pTRouteFlight == NULL
*   -4 -  
*   -5 -       
*/
	int TArmoringTicket::armoringTickets()
	{
		int errorCode;
		if (this->pIDataAccess   == NULL)
		{
			return -1;
		}
		if (this->pIFitingFlight == NULL)
		{
			return -2;
		}
		if (this->pTRouteFlight  == NULL)
		{
			return -3;
		}
		if (this->pTRouteFlight->size() == 0)
		{
			return -4;
		}
		errorCode = this->pIDataAccess->armoringTicket(this->pTRouteFlight);
		//      
		if (errorCode < 0)
		{
			return -5;
		}
		return 0;
	}
/**
* :
*    ,   
* :
*   price -   
*   startAirport -  ,    
*   finishAirport -  ,    
*  :
*    
*    0 -   
*   -1 - pIDataAccess == NULL
*   -2 - pIFitingFlight == NULL
*   -3 - pTRouteFlight == NULL
*   -4 -       
*/
	int TArmoringTicket::getRouteFlight(int price, int startAirport, int finishAirport)
	{
		int errorCode;
		if (this->pIDataAccess   == NULL)
		{
			return -1;
		}
		if (this->pIFitingFlight == NULL)
		{
			return -2;
		}
		if (this->pTRouteFlight  == NULL)
		{
			return -3;
		}
		this->pTRouteFlight->empty();
		errorCode = this->pIFitingFlight->getRouteFlight(price, startAirport, finishAirport, this->pTRouteFlight); 
		//      
		if (errorCode < 0)
		{
			return errorCode - 4;
		}
		return 0;
	}
	TRouteFlight* TArmoringTicket::getRouteFlight(){
		return pTRouteFlight;
	}
}