/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//                                  //
//                             . ..                        //
//                                                                         //
//         : TDataAccess.cpp                                           //
//                                                                         //
//   :               //
//                                                           //
//                                                                         //
//  ()   :  ..,  ..,  ..                    //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

#include "TDataAccess.h"
namespace NS_DATA_ACCESS{
	TDataAccess::TDataAccess(void)
	{
		this->pIGetNewAirport = new NS_MANAGEMENT_AIRPORT::GetNewAirport();
	}
//  
	TDataAccess::TDataAccess(const TDataAccess &TDA)
	{
		this->pIGetNewAirport = TDA.pIGetNewAirport;
		this->AllAirpor_data  = TDA.AllAirpor_data;
	}

	TDataAccess::~TDataAccess(void)
	{
		delete this->pIGetNewAirport;
	}

	TAllAirport    * TDataAccess::getPointAllAirport()
	{
		return &(this->AllAirpor_data);
	}

	TAirportStruct * TDataAccess::getFlights(int NumberAirport)
	{
		IManagementAirport * pTemp;
		if (!isAirportExist(NumberAirport))
		{
			return NULL;
		}
		else
		{
			pTemp = this->AllAirpor_data[NumberAirport].pIManagementAirport;
			if (pTemp == NULL) 
			{
				return NULL;
			}
			return (pTemp->getFlights());
		}
	}
/**
* :
*         
* :
*   pRouteFlight -     
*  :
*    
*   -1 -     
*   -2 -    
*/
	int TDataAccess::armoringTicket(TRouteFlight* pRouteFlight)
	{
		int errorCode;
		TRouteFlight ::iterator p_Iter;
		//        
		for ( p_Iter = pRouteFlight->begin( ); p_Iter != pRouteFlight->end( ); p_Iter++ )
		{
			//   
			if(isAirportExist((*p_Iter).NumberAirport))
			{
				errorCode = this->AllAirpor_data[p_Iter->NumberAirport].
					pIManagementAirport->armoringTicket(p_Iter->NumberFlight);
				//     
				if (errorCode<0)
				{
					return -2;
				}
			}
			else
			{
				return -1;
			}
		}
		return 0;
	}
/**
* :
*      
* :
*   NumberAirport -  
*   nameAirport -  
*  :
*    
*   -1 -      
*/
	int TDataAccess::addAirport    (int NumberAirport, string nameAirport)
	{
		TAirportLink AirportLink;
		//   
		if (isAirportExist(NumberAirport))
		{
			return -1;
		}
		AirportLink.pIManagementAirport = this->pIGetNewAirport->getNewAirport(NumberAirport);
		AirportLink.name                = nameAirport;
		//    
		this->AllAirpor_data.insert(TAllAirport::value_type(NumberAirport, AirportLink));
		return 0;
	}
/**
* :
*       
* :
*   name -  
*   NumberFlight -  
*   price -  
*   startAirport -  ,    
*   finishAirport -  ,    
*  :
*    
*   -1 -       / 
*   -2 -    
*/
	int TDataAccess::addFlight     (string name, int NumberFlight, int price, int startAirport, int finishAirport)
	{
		int errorCode;
		if ((!isAirportExist(startAirport))||(!isAirportExist(finishAirport)))
		{
			return -1;
		}
		errorCode = this->AllAirpor_data[startAirport].pIManagementAirport->addFlight(NumberFlight, name, price, startAirport, finishAirport);
		//     
		if (errorCode<0)
		{
			return -2;
		}
		errorCode = this->AllAirpor_data[finishAirport].pIManagementAirport->addFlight(NumberFlight, name, price, startAirport, finishAirport);
		//     
		if (errorCode<0)
		{
			this->AllAirpor_data[startAirport].pIManagementAirport->removeFlight(NumberFlight);
			return -2;
		}
		return 0;
	}
/**
* :
*    
* :
*   NumberAirport -  
*   NumberFlight -  
*  :
*    
*   -1 -      
*   -2 -      
*/
	int TDataAccess::removeFlight  (int NumberAirport, int NumberFlight)
	{
		int errorCode;
		if (!isAirportExist(NumberAirport))
		{
			return -1;
		}
		TFlightLink pTFlightLink;
		errorCode = this->AllAirpor_data[NumberAirport].pIManagementAirport->getFlight(NumberFlight,pTFlightLink);
		if (errorCode<0)
		{
			return -2;
		}
		errorCode = this->AllAirpor_data[NumberAirport].pIManagementAirport->removeFlight(NumberFlight);
		//     
		if (errorCode<0)
		{
			return -2;
		}
		if (NumberAirport == pTFlightLink.startingAirport) 
			errorCode = this->AllAirpor_data[pTFlightLink.finishAirport].pIManagementAirport->removeFlight(NumberFlight);
		else
			errorCode = this->AllAirpor_data[pTFlightLink.startingAirport].pIManagementAirport->removeFlight(NumberFlight);
		if (errorCode<0)
		{
			return -2;
		}
		return 0;
	}
/**
* :
*    
* :
*   NumberAirport -  
*  :
*    
*/
//    
	int TDataAccess::removeAirport (int NumberAirport)
	{
		//   
		if (!isAirportExist(NumberAirport))
		{
			//  
			return 1;
		}

		TAirportStruct ar_str;
		TAirportStruct::iterator It_air;

		int NR;

		ar_str = *(AllAirpor_data[NumberAirport].pIManagementAirport->getFlights());

		for ( It_air = ar_str.begin( ); It_air != ar_str.end( ); It_air++ )
		{
			NR = It_air->first;
			this->removeFlight(NumberAirport,NR);
		}
		this->AllAirpor_data.erase(NumberAirport);
		return 0;
	}

	// 
/**
* :
*        
* :
*   NumberAirport -  
*  :
*   true  - 
*   false -  
*/
	bool TDataAccess::isAirportExist(int NumberAirport)
	{
		TAllAirport ::const_iterator fe;
		fe = this->AllAirpor_data.find (NumberAirport);
		if (fe == this->AllAirpor_data.end()) 
		{
			return false;
		}
		else 
		{
			return true;
		}
	}
}