/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//                                  //
//                             . ..                        //
//                                                                         //
//         : TFitingFlight.cpp                                         //
//                                                                         //
//   :               //
//                                                            //
//                                                                         //
//  ()   :  ..,  ..,  ..                    //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

#include "TFitingFlight.h"

namespace NS_FITING_FLIGHT {
//,     
	typedef struct{
		int priceWay; //    
		int priorAirport; //   
		int NF; //   
	} day_link;

	TFitingFlight::TFitingFlight(IDataAccess * pIDataAccess)
	{
		this->pIDataAccess = pIDataAccess;
	}

	TFitingFlight::~TFitingFlight(void)
	{
		this->pIDataAccess = NULL;
	}
/**
* :
*        
* :
*   price -   
*   startAirport -  
*   finishAirport -  
*   pTRouteFlight -  ,      
*  :
*    
*   -1 -    ,   
*   -2 -  ,  
*/
	int TFitingFlight::getRouteFlight(int price, int startAirport, int finishAirport, TRouteFlight * pTRouteFlight)
	{
		pTRouteFlight->clear();
		map <int , day_link>       est_Way;
		map <int , bool>           airport_is_include;
		map <int , bool>::iterator airport_is_include_Iter, i2;

		int d_curent;
		int delta;
		int min;

		day_link tmp_day_link;
		TAllAirport              * pTAllAirport;
		TAirportStruct           * pTmpAirportStruct;
		TAirportStruct::iterator   pTmpAirportStruct_Iter;
		TAllAirport::iterator      TAllAirport_Iter;

		if(!this->isAirportExist(startAirport)){return -1;}
		if(!this->isAirportExist(finishAirport)){return -2;}

		//  
		tmp_day_link.priceWay     = -1;
		tmp_day_link.priorAirport = -1;
		tmp_day_link.NF           = -1;

		pTAllAirport = this->pIDataAccess->getPointAllAirport();
		for ( TAllAirport_Iter = pTAllAirport->begin( ) ; TAllAirport_Iter != (pTAllAirport->end( )); TAllAirport_Iter++)
		{
			est_Way           [TAllAirport_Iter->first] = tmp_day_link;
			airport_is_include[TAllAirport_Iter->first] = false;
		}
		est_Way[startAirport].priceWay = 0;
		est_Way[startAirport].priorAirport = startAirport;
//		est_Way[startAirport].NF = 0;
		d_curent = startAirport;

		// 


		i2 = airport_is_include.begin( );
		for(i2 ++;i2 != airport_is_include.end( ); i2++)
		{
			airport_is_include [d_curent] = true;
			pTmpAirportStruct = (*pTAllAirport)[d_curent].pIManagementAirport->getFlights();
			for ( pTmpAirportStruct_Iter = pTmpAirportStruct->begin( ) ; 
				pTmpAirportStruct_Iter != pTmpAirportStruct->end( ); 
				pTmpAirportStruct_Iter++)
			{
				if(pTmpAirportStruct_Iter->second.startingAirport == d_curent)
				{
					if(est_Way[pTmpAirportStruct_Iter->second.finishAirport].priceWay == -1)
					{
						est_Way[pTmpAirportStruct_Iter->second.finishAirport].priceWay = pTmpAirportStruct_Iter->second.price;
						est_Way[pTmpAirportStruct_Iter->second.finishAirport].priorAirport = d_curent;
						est_Way[pTmpAirportStruct_Iter->second.finishAirport].NF = pTmpAirportStruct_Iter->first;
					}
					else
					{
						delta = est_Way[pTmpAirportStruct_Iter->second.finishAirport].priceWay - 
							(est_Way[pTmpAirportStruct_Iter->second.startingAirport] .priceWay + 
							pTmpAirportStruct_Iter->second.price);
						if (delta > 0 )
						{
							est_Way[pTmpAirportStruct_Iter->second.finishAirport].priceWay -= delta;
							est_Way[pTmpAirportStruct_Iter->second.finishAirport].priorAirport = d_curent;
							est_Way[pTmpAirportStruct_Iter->second.finishAirport].NF = pTmpAirportStruct_Iter->first;
						}
					}
				}
			}
			min = -1;
			for ( airport_is_include_Iter  = airport_is_include.begin( ) ; 
				  airport_is_include_Iter != airport_is_include.end( );
				  airport_is_include_Iter++)
			{
				if ((min == -1)&& (!airport_is_include_Iter->second))
				{
					min = est_Way[airport_is_include_Iter->first].priceWay;
					d_curent = airport_is_include_Iter->first;
				}
				else
				{
					if ((min > est_Way[airport_is_include_Iter->first].priceWay)&&
						(!airport_is_include_Iter->second)&&
						(airport_is_include[est_Way[airport_is_include_Iter->first].priorAirport]))
					{
						min = est_Way[airport_is_include_Iter->first].priceWay;
						d_curent = airport_is_include_Iter->first;
					}
				}
			}
			
		}

		if( est_Way[finishAirport].priceWay > price )
		{
			return -3;
		}

		int N_A;
		TTicket tmpTTicket;
		N_A = finishAirport;
		while (N_A != startAirport)
		{
			if (est_Way[N_A].priorAirport == -1) 
			{
				pTRouteFlight->clear();
				return -4;
			}
			tmpTTicket.NumberAirport = N_A;
			tmpTTicket.NumberFlight  = est_Way[N_A].NF;
			pTRouteFlight->push_back(tmpTTicket);
			tmpTTicket.NumberAirport = est_Way[N_A].priorAirport;
			tmpTTicket.NumberFlight  = est_Way[N_A].NF;
			pTRouteFlight->push_back(tmpTTicket);
			N_A = est_Way[N_A].priorAirport;
		}		

		return 0;
	}
	bool TFitingFlight::isAirportExist(int NumberAirport){
		TAllAirport *ar;
		ar = this->pIDataAccess->getPointAllAirport();
		TAllAirport ::const_iterator fe;
		fe = ar->find (NumberAirport);
		if (fe == ar->end()) 
		{
			return false;
		}
		else 
		{
			return true;
		}
	}
}