// frame_dll_jNI.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"

#include "jni.h"
#include <string>
#include "airport_visualization_nativ_ManegingFlight.h"

IArmoringTicket   * pIArmoringTicket;
IManagementFlight * pIManagementFlight;

#ifdef _MANAGED
#pragma managed(push, off)
#endif

BOOL APIENTRY DllMain( HMODULE hModule,
					  DWORD  ul_reason_for_call,
					  LPVOID lpReserved
					  )
{
	NS_DATA_ACCESS::TDataAccess * pTDataAccess = new NS_DATA_ACCESS::TDataAccess();
	pIManagementFlight = new NS_MANAGEMENT_FLIGH::TManagementFlight(pTDataAccess);
	pIArmoringTicket   = new NS_ARMORING_TICKET::TArmoringTicket(pTDataAccess);
	return TRUE;
}

JNIEXPORT jint JNICALL Java_airport_1visualization_nativ_1ManegingFlight_addAirport
  (JNIEnv * env, jobject, jint NA, jstring NAMEA)
{
	const char* msg=env->GetStringUTFChars(NAMEA,0);
	string name;
	name = msg;
    int NA1 = (int)NA;
	int error;
	error = pIManagementFlight->addAirport(NA1,name);
	return error;
}

/*
 * Class:     airport_visualization_nativ_ManegingFlight
 * Method:    addFlight
 * Signature: (Ljava/lang/String;IIII)I
 */
JNIEXPORT jint JNICALL Java_airport_1visualization_nativ_1ManegingFlight_addFlight
  (JNIEnv *env, jobject, jstring NAMEA, jint p1, jint p2, jint p3, jint p4) 
{
	const char* msg=env->GetStringUTFChars(NAMEA,0);
	string name;
	name = msg;
    int p11 = (int)p1;
	int p12 = (int)p2;
	int p13 = (int)p3;
	int p14 = (int)p4;
	int error;
	error = pIManagementFlight->addFlight(name,p11,p12,p13,p14);
	env->ReleaseStringUTFChars(NAMEA, msg);
	return error;
}

/*
 * Class:     airport_visualization_nativ_ManegingFlight
 * Method:    removeFlight
 * Signature: (II)I
 */
JNIEXPORT jint JNICALL Java_airport_1visualization_nativ_1ManegingFlight_removeFlight
(JNIEnv *env, jobject, jint p1, jint p2)
{
	int p11 = (int)p1;
	int p12 = (int)p2;
	int error;
	error = pIManagementFlight->removeFlight(p11, p12);
	return error;
}

/*
 * Class:     airport_visualization_nativ_ManegingFlight
 * Method:    removeAirport
 * Signature: (I)I
 */
JNIEXPORT jint JNICALL Java_airport_1visualization_nativ_1ManegingFlight_removeAirport
  (JNIEnv *, jobject, jint p1)
{
	int p11 = (int)p1;
	int error;
	error = pIManagementFlight->removeAirport(p11);
	return error;
}

#ifdef _MANAGED
#pragma managed(pop)
#endif

